---
    - name: Install Witness Node
      hosts: witness_node
      become: true
      
      vars:
        instance_user: 'ubuntu'
        gitlab_job: '753824421'
        witness_node_dir: '/home/ubuntu/blockchain'
        p2p_endpoint: '127.0.0.1:9777'
        rpc_endpoint: '0.0.0.0:8090'
        seed_nodes: '[]'
        genesis: 'genesis.json'
        witness_ids: '["1.6.1", "1.6.2", "1.6.3", "1.6.4", "1.6.5", "1.6.6", "1.6.7", "1.6.8", "1.6.9", "1.6.10", "1.6.11"]'

      tasks:
        - name: Install dependencies
          become: yes
          apt:
            name: "{{ packages }}"  
          vars:
            packages:    
            - wget
            - zip
            state: latest 
      
        - name: Download witness artifact
          become: yes
          become_user: "{{ instance_user }}"
          get_url: 
            url: https://gitlab.com/PBSA/peerplays/-/jobs/{{ gitlab_job }}//artifacts/download
            dest: /home/ubuntu/artifacts.zip

        - name: Unzip witness_node artifact
          become: yes
          become_user: "{{ instance_user }}"
          shell: |
            unzip -j /home/ubuntu/artifacts.zip */witness_node -d /home/ubuntu/blockchain
            unzip -j /home/ubuntu/artifacts.zip */cli_wallet -d /home/ubuntu/blockchain
            rm artifacts.zip

        - name: Configure witness node
          become: yes
          become_user: "{{ instance_user }}"
          shell: |
            cd "{{ witness_node_dir }}"
            ./witness_node --create-genesis-json genesis.json
            sed -i 's/.*p2p-endpoint.*/p2p-endpoint = {{ p2p_endpoint }}/' ./witness_node_data_dir/config.ini
            sed -i 's/.*seed-nodes.*/seed_nodes = {{ seed_nodes }}/' ./witness_node_data_dir/config.ini
            sed -i 's/.*rpc-endpoint.*/rpc-endpoint = {{ rpc_endpoint }}/' ./witness_node_data_dir/config.ini
            sed -i 's/.*enesis-json.*/genesis-json = {{ genesis }}/' ./witness_node_data_dir/config.ini
            sed -i 's/.*enable-stale-production.*/enable-stale-production = true/' ./witness_node_data_dir/config.ini
            sed -i 's/.*required-participation.*/required-participation = false/' ./witness_node_data_dir/config.ini
            sed -i 's/.*witness-ids.*/witness-ids = {{ witness_ids }}/' ./witness_node_data_dir/config.ini

        - name: Move the witness service file
          become: yes
          shell: |
            mv /tmp/witness.service /etc/systemd/system 
        
        - name: Start witness service  
          become: yes
          service:
            name: witness
            state: started